<script>
import Vue from 'vue';
import GradientLineBlock from './gradient-line-block.vue';
import FeatureItemCard from './feature-item-card.vue';

export default Vue.extend({
  name: 'FeaturesBlock',
  components: {
    GradientLineBlock,
    FeatureItemCard,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    features: {
      type: Array,
      required: true,
      default: null,
    },
    relatedContent: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      themes: {},
      isLoading: true,
    };
  },
  computed: {
    titleTag() {
      return this.data.header.subtitle ? 'h4' : 'h3';
    },
    itemTitleTag() {
      return this.data.header.subtitle ? 'h5' : 'h4';
    },
    tier() {
      return `gitlab_${this.data.tier}`;
    },
  },
  created() {
    this.setThemes();
  },
  mounted() {
    window.onload = () => {
      this.isLoading = false;
    };
  },
  methods: {
    setThemes() {
      const content = {};
      let otherId = false;

      // formatting and merging content
      this.data.pricing_themes.forEach((entry) => {
        if (entry.theme) {
          content[entry.theme] = { ...entry, items: [] };
        } else {
          content[entry.id] = { ...entry, items: [] };
          otherId = entry.id;
        }
      });

      this.features.forEach((entry) => {
        if (entry[this.tier] === true) {
          let key = otherId;
          const feature = { ...entry };

          if (
            entry.title in this.relatedContent &&
            'video' in this.relatedContent[entry.title]
          ) {
            feature.video = this.relatedContent[entry.title].video;
          }

          if (
            'pricing_theme' in entry &&
            entry.pricing_theme &&
            entry.pricing_theme in content
          ) {
            key = entry.pricing_theme;
          }

          content[key].items.push(feature);
        }
      });

      /* Sort features by pps_aggregate */
      Object.values(content).forEach((entry) => {
        entry.items.sort((a, b) => b.pps_aggregate - a.pps_aggregate);
      });
      this.themes = content;
    },
  },
});
</script>

<template>
  <section :id="data.id" class="features-block">
    <div
      class="features-block__placeholder"
      :class="{ 'features-block__placeholder--loading': isLoading }"
    >
      <div class="features-block__placeholder__loader"></div>
    </div>
    <GradientLineBlock :data="data.header">
      <SlpRow
        v-for="(theme, themeIndex) in themes"
        :id="theme.id"
        :key="themeIndex"
        class="features-block__content"
      >
        <SlpTypography
          v-if="theme.text || theme.theme || theme.link"
          :tag="titleTag"
          variant="heading4 slp-mb-32"
          class="description"
        >
          <SlpTypography
            v-if="theme.theme"
            tag="span"
            variant="heading4-bold"
            >{{ theme.theme }}</SlpTypography
          >
          <span v-if="theme.text">
            {{ theme.text }}
          </span>
          <SlpLink
            v-if="theme.link"
            :href="theme.link.url"
            :data-ga-name="theme.link.data_ga_name"
            :data-ga-location="theme.link.data_ga_location"
          >
            {{ theme.link.text }}
          </SlpLink>
        </SlpTypography>
        <SlpRow v-if="theme.items" class="features-block__card-container">
          <SlpColumn
            v-for="(item, itemIndex) in theme.items"
            :key="itemIndex"
            class="features-block__card slp-mb-48"
          >
            <FeatureItemCard :data="item" :title-tag="titleTag" />
          </SlpColumn>
        </SlpRow>
      </SlpRow>
    </GradientLineBlock>
  </section>
</template>

<style lang="scss" scoped>
.features-block {
  position: relative;
  &__placeholder {
    background: $color-primary-300;
    position: absolute;
    width: 100%;
    height: 100%;
    left: 0;
    right: 0;
    top: 0;
    opacity: 0;
    transition: opacity 0.3s ease-in-out;
    pointer-events: none;

    &--loading {
      opacity: 0.7;
      pointer-events: all;
    }

    &__loader {
      position: absolute;
      left: 0;
      top: $spacing-160;
      right: 0;
      margin: 0 auto;
      border: $spacing-8 solid $color-primary-100;
      border-top: $spacing-8 solid $color-accent-400;
      border-radius: 50%;
      width: $spacing-48;
      height: $spacing-48;
      animation: spin 2s linear infinite;
    }
  }

  @keyframes spin {
    0% {
      transform: rotate(0deg);
    }
    100% {
      transform: rotate(360deg);
    }
  }

  &__content {
    flex-direction: column;
  }

  &__card-container {
    align-items: flex-start;
    justify-content: space-between;
  }

  &__card {
    width: 100%;
    max-width: 350px;

    @media (min-width: 970px) {
      width: 350px;
      min-width: 350px;
    }
  }
}
</style>
